import { createEffect, createMemo, on } from 'solid-js';
export function createEditorControlledValue(view, code) {
    const memoizedCode = createMemo(code);
    createEffect(on(view, (view) => {
        if (view) {
            createEffect(on(memoizedCode, (code) => {
                const localValue = view?.state.doc.toString();
                if (localValue !== code) {
                    view.dispatch({
                        changes: {
                            from: 0,
                            to: localValue?.length,
                            insert: code ?? '',
                        },
                    });
                }
            }));
        }
    }));
}
