import { createSignal } from 'solid-js';
import { EditorView } from '@codemirror/view';
import { createCompartmentExtension } from '../core/createCompartmentExtension';
export function createEditorFocus(view, onFocusChange) {
    const [focused, $setFocused] = createSignal(view()?.hasFocus ?? false);
    const focusListener = EditorView.updateListener.of((viewUpdate) => {
        if (viewUpdate.focusChanged) {
            const focused = viewUpdate.view.hasFocus;
            $setFocused(focused);
            onFocusChange?.(focused, viewUpdate);
        }
    });
    void createCompartmentExtension(focusListener, view);
    return {
        focused,
        setFocused(focused) {
            $setFocused(focused);
            if (focused) {
                view()?.focus();
            }
        },
    };
}
