import { createEffect, on, untrack } from 'solid-js';
import { EditorView } from '@codemirror/view';
import { createCompartmentExtension } from '../core/createCompartmentExtension';
function getReadOnlyExtensions(readOnly) {
    return readOnly ? EditorView.editable.of(false) : [];
}
export function createEditorReadonly(view, readOnly) {
    const localReadOnly = readOnly ? untrack(readOnly) : false;
    const reconfigure = createCompartmentExtension(getReadOnlyExtensions(localReadOnly), view);
    createEffect(on(readOnly, (readOnly) => reconfigure(getReadOnlyExtensions(readOnly))));
}
