import { Accessor } from 'solid-js';
import { EditorView, ViewUpdate } from '@codemirror/view';
import { Extension } from '@codemirror/state';
export interface CreateCodeMirrorProps {
    /**
     * The initial value of the editor
     */
    value: string;
    /**
     * Fired whenever the editor code value changes.
     */
    onValueChange: (value: string) => void;
    /**
     * Fired whenever a change occurs to the document. There is a certain difference with `onChange`.
     */
    onModelViewUpdate: (vu: ViewUpdate) => void;
}
/**
 * Creates a CodeMirror editor instance.
 */
export declare function createCodeMirror(props?: Partial<CreateCodeMirrorProps>): {
    readonly editorView: Accessor<EditorView>;
    readonly ref: import("solid-js").Setter<HTMLElement>;
    readonly createExtension: (extension: Extension | Accessor<Extension | undefined>) => import("./createCompartmentExtension").CompartmentReconfigurationCallback;
};
