import { Accessor } from 'solid-js';
import { Extension } from '@codemirror/state';
import { EditorView } from '@codemirror/view';
export declare type LazyCompartmentReconfigurationCallback = {
    loading: boolean;
} & ((extension: Extension) => void);
/**
 * Creates a lazy compartment extension for the given CodeMirror EditorView,
 * configured only after the Promise will be resolved.
 **
 * See {@link https://codemirror.net/examples/reconfigure/} for use cases and examples of `Compartments`.
 * Check out {@link https://codemirror.net/docs/ref/#state.Compartment} for more details about Compartment API.
 *
 * @param fn The Promise callback that will return the extension once resolved.
 * @param view The CodeMirror EditorView
 */
export declare function createLazyCompartmentExtension(fn: () => Promise<Extension | null | undefined>, view: Accessor<EditorView | undefined>): LazyCompartmentReconfigurationCallback;
